allocation-manager/django/ResourceAllocationManager/ResourceAllocationManager/urls.py
from django.conf.urls import include,url
from django.contrib import admin
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^dashboard/', include('dashboard.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root= settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root= settings.MEDIA_ROOT)

allocation-manager/django/ResourceAllocationManager/dashboard/urls.py
from django.conf.urls import url
from . import views

app_name ='dashboard'

urlpatterns = [
    # /dashboard/
    # url(r'^$', views.index, name='index'),
    url(r'^$', views.IndexView.as_view(), name='index'),

    # /dashboard/reviewer
    url(r'^reviewer/$', views.ReviewerView.as_view(), name='reviewer'),


    # /dashboard/admin
    url(r'^admin/$', views.AdminView.as_view(), name='admin'),

    # /dashboard/admin/141
    url(r'^admin/request-view/$', views.AdminRequestView.as_view(), name='admin-request-view'),



    url(r'^register/$', views.UserFormView.as_view(), name='register'),

    # /dashboard/712/
    # url(r'^(?P<request_id>[0-9]+)/$', views.detail, name='detail'),
    url(r'^(?P<pk>[0-9]+)/$', views.DetailView.as_view(), name='detail'),


    # /dashboard/request/add
    url(r'^request/add/$', views.RequestCreate.as_view(), name='request-add'),

    # /dashboard/request/2/
    url(r'^request/(?P<pk>[0-9]+)/$', views.RequestUpdate.as_view(), name='request-update'),

    # /dashboard/request/2/delete/
    url(r'^request/(?P<pk>[0-9]+)/delete/$', views.RequestDelete.as_view(), name='request-delete'),
]

allocation-manager/django/ResourceAllocationManager/dashboard/models.py
from __future__ import unicode_literals

from django.db import models
from django.core.urlresolvers import reverse
#from datetime import date

# Create your models here.
class Request(models.Model):
    request_title = models.CharField(max_length=250)
    request_description = models.CharField(max_length=500)
    request_status = models.CharField(max_length=20)
    allocation_type = models.CharField(blank=True,max_length=100)
    applications_to_be_used = models.CharField(blank=True,max_length=100)
    disk_usage_range_per_job = models.BigIntegerField(blank=True,null=True)
    document = models.FileField(blank=True)
    field_of_science = models.CharField(blank=True,max_length=50)
    keywords = models.CharField(blank=True,max_length=100)
    max_memory_per_cpu = models.BigIntegerField(blank=True,null=True)
    num_cpus_per_job = models.BigIntegerField(blank=True,null=True)
    request_reviewed_and_funded_by = models.CharField(blank=True,max_length=100)
    request_date = models.DateTimeField(blank=True, null=True)
    service_units = models.BigIntegerField()
    specific_resource_selection = models.CharField(blank=True,max_length=100)
    typical_su_per_job = models.BigIntegerField(blank=True,null=True)

    def get_absolute_url(self):
        return reverse('dashboard/detail.html', kwargs={'pk': self.pk})


    def __str__(self):
        return self.request_title + ' - ' + self.request_status

allocation-manager/django/ResourceAllocationManager/dashboard/forms.py
from django.contrib.auth.models import User
from django import forms


class UserForm(forms.ModelForm):
    password = forms.CharField(widget=forms.PasswordInput)

    class Meta:
        model = User
        fields = ['username', 'email', 'password']

allocation-manager/django/ResourceAllocationManager/dashboard/views.py
from django.views import generic
from django.views.generic import View
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login
from django.core.urlresolvers import reverse_lazy
from .models import Request
from .forms import UserForm


class IndexView(generic.ListView):
    template_name = 'dashboard/index.html'
    context_object_name = 'all_requests'

    def get_queryset(self):
        return Request.objects.all()

class ReviewerView(generic.ListView):
    template_name = 'dashboard/reviewer.html'
    context_object_name = 'all_requests'

    def get_queryset(self):
        return Request.objects.all()


class AdminView(generic.ListView):
    template_name = 'dashboard/admin.html'
    context_object_name = 'all_requests'

    def get_queryset(self):
        return Request.objects.all()

class AdminRequestView(generic.ListView):
    model = Request
    template_name = 'dashboard/admin-request-view.html'




class DetailView(generic.DetailView):
    model = Request
    template_name = 'dashboard/detail.html'


class RequestCreate(CreateView):
    model = Request
    fields = ['request_title', 'request_status', 'request_description', 'allocation_type',
              'applications_to_be_used', 'disk_usage_range_per_job', 'document', 'field_of_science',
              'keywords', 'max_memory_per_cpu', 'num_cpus_per_job', 'request_reviewed_and_funded_by',
              'request_date', 'service_units', 'specific_resource_selection', 'typical_su_per_job']


class RequestUpdate(UpdateView):
    model = Request
    fields = ['request_title', 'request_status', 'request_description', 'allocation_type',
              'applications_to_be_used', 'disk_usage_range_per_job', 'document', 'field_of_science',
              'keywords', 'max_memory_per_cpu', 'num_cpus_per_job', 'request_reviewed_and_funded_by',
              'request_date', 'service_units', 'specific_resource_selection', 'typical_su_per_job']

class RequestDelete(DeleteView):
    model = Request
    success_url = reverse_lazy('dashboard:index')


class UserFormView(View):
    form_class = UserForm
    template_name = 'dashboard/registration_form.html'


    # Display a blank form
    def get(self, request):
        form = self.form_class(None)
        return render(request, self.template_name, {'form': form})

    # process form data
    def post(self, request):
        form = self.form_class(request.POST)

        if form.is_valid():
            user = form.save(commit=False)

            # cleaned (normalized) data
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user.set_password(password)
            user.save()

            # returns user objects if credentials are correct
            user = authenticate(username=username, password=password)
            if user is not None:
                if user.is_active:
                    login(request, user)
                    return redirect('dashboard:index')
        return render(request, self.template_name, {'form': form})

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/admin-request-view.html
{% extends 'dashboard/base.html' %}
{% block title %} Allocation Manager - Admin{% endblock %}
{% block body %}


        <!-- All Requests-->
        <div class="container">

          <div class="form-group">
            <h3>Request Title <small>Title goes here</small></h3>
            <h4>Select a Reviewer </h4>
                <select class="selectpicker" data-style="btn-primary" data-live-search="true">

                        <option>Reviewer 1</option>
                        <option>Reviewer 2</option>
                        <option>Reviewer 3</option>
                        <option>Reviewer 4</option>
                        <option>Reviewer 5</option>
                        <option>Reviewer 6</option>
                   </select>
        </div>
            <table class="table table-hover table-bordered table-striped table-responsive">
                <thead class="thead-inverse">
                  <tr style="background-color: #337ab7;color:white">
                    <th>Request Fields</th>
                    <th>User Submitted</th>
                    <th>Reviewer Submitted</th>
                    </tr>
                </thead>
                <tbody>

                    <tr>
                        <td>Allocation type</td>
                        <td>Community</td>
                        <td>Community</td>
                    </tr>
                    <tr>
                        <td>Applications to be used</td>
                        <td>
                            <div class="dropdown">
                              <button class="btn btn-primary dropdown-toggle" type="button" data-toggle="dropdown">Selected Applications
                              <span class="caret"></span></button>
                              <ul class="dropdown-menu">
                                <li>HTML</li>
                                <li>CSS</li>
                                <li>JavaScript</li>
                              </ul>
                            </div>
                        </td>
                        <td>
                            <div class="dropdown">
                              <button class="btn btn-primary dropdown-toggle" type="button" data-toggle="dropdown">Selected Applications
                              <span class="caret"></span></button>
                              <ul class="dropdown-menu">
                                <li>HTML</li>
                                <li>CSS</li>
                                <li>JavaScript</li>
                              </ul>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Disk Usage Range Per Job</td>
                        <td>50-500</td>
                        <td>50-250</td>
                    </tr>
                    <tr>
                        <td>Field of Science</td>
                        <td>Science Gateways</td>
                        <td>Science Gateways</td>
                    </tr>
                    <tr>
                        <td>Keywords</td>
                        <td>keyword 1, keyword 2, keyword 3</td>
                        <td>keyword 1, keyword 2, keyword 3</td>
                    </tr>
                    <tr>
                        <td>Max Memory Per CPU</td>
                        <td>40GB</td>
                        <td>20GB</td>
                    </tr>
                    <tr>
                        <td>Num CPUs Per Job</td>
                        <td>4</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>Service Units</td>
                        <td>50000</td>
                        <td>45000</td>
                    </tr>
                    <tr>
                        <td>Typical Service Units/Job</td>
                        <td>60</td>
                        <td>49</td>
                    </tr>
                </tbody>
             </table>
            <button type="button" class="btn btn-success" data-toggle="modal" data-target="#approve">Approve</button>
            <!-- Modal -->
                  <div class="modal fade" id="approve" role="dialog">
                    <div class="modal-dialog modal-sm">
                      <div class="modal-content">
                        <div class="modal-header">
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                          <h4 class="modal-title">Approve Request</h4>
                        </div>
                        <div class="modal-body">

                          <div class="form-group">
                                Start Date :
                                <input type="date" id="start" style="border: none;" >
                          </div>
                          <div class="form-group">
                                End Date :
                                <input type="date"id="end" style="border: none;">
                          </div>
                          <div>
                                Allocation Units:
                                <input type="text"id="allocation-units">
                          </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-success" >Approve</button>
                          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        </div>
                      </div>
                    </div>
                  </div>
            <button type="button" class="btn btn-danger" data-toggle="modal" data-target="#reject">Reject</button>
            <!-- Modal -->
                  <div class="modal fade" id="reject" role="dialog">
                    <div class="modal-dialog modal-sm">
                      <div class="modal-content">
                        <div class="modal-header">
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                          <h4 class="modal-title">Reject Request</h4>
                        </div>
                        <div class="modal-body">

                          <div class="form-group">
                                Reason :
                                <input type="text" id="reject-reason" >
                          </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-danger" >Reject</button>
                          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        </div>
                      </div>
                    </div>
                  </div>
        </div>

 {%  endblock %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/admin.html
{% extends 'dashboard/base.html' %}
{% block title %} Allocation Manager - Admin{% endblock %}
{% block body %}
    {% if all_requests %}
        <h3 style="margin-left: 7%">Requests to Approve/Reject</h3>
        <!-- All Requests-->
        <div class="container">
          <table class="table table-hover table-bordered table-striped table-responsive">
            <thead class="thead-inverse">
              <tr style="background-color: #337ab7;color:white">
                <th>Request-ID</th>
                <th>Request Title</th>
                <th>Request Description</th>
                <th>Allocation Requested</th>
                <th style="text-align: center">Assign Reviewer(s)</th>
              </tr>
            </thead>
            <tbody>
                {% for request in all_requests %}
                  <tr>
                    <td>{{ request.id }}</td>
                    <td>{{ request.request_title }}</td>
                    <td>{{ request.request_description }}</td>
                    <td>{{ request.service_units}}</td>
                    <td>
                        <div class="form-group">
                            <div class="col-sm-10">
                                <select class="selectpicker" data-style="btn-primary" data-live-search="true" multiple>
                                    <option>Reviewer 1</option>
                                    <option>Reviewer 2</option>
                                    <option>Reviewer 3</option>
                                    <option>Reviewer 4</option>
                                </select>
                                <button type="submit" class="btn btn-success">Assign</button>
                            </div>
                        </div>
                    </td>
                  </tr>
                {% endfor %}
            </tbody>
          </table>
        </div>

    {%  else %}
        <h3>No Requests to Review</h3>
    {% endif %}
{%  endblock %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title%} Allocation Manager - {% endblock %}</title>
    <!-- Loads the path to your static files -->
    {% load staticfiles %}
    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Spectral+SC" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.7.5/css/bootstrap-select.min.css">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/4.4.5/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />
    <link rel="stylesheet" type="text/css" href="{% static 'dashboard/style.css' %}"/>
    <script
      src="https://code.jquery.com/jquery-3.2.1.min.js"
      integrity="sha256-hwg4gsxgFZhOsEEamdOYGBf13FyQuiTwlAQgxVSNgt4="
      crossorigin="anonymous"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.7.5/js/bootstrap-select.min.js"></script>
    <!-- the main fileinput plugin file -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/4.4.5/js/fileinput.min.js"></script>
</head>
<body>
    <nav class="navbar navbar-inverse">
    <div class="container-fluid">
        <!--Header -->
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#topNavBar">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="{%  url 'dashboard:index' %}">Allocation Manager</a>
        </div>

        <!-- Requests -->
        <div class="collapse navbar-collapse" id="topNavBar">

            <ul class="nav navbar-nav">
                <li class="active">
                    <a href="{% url 'dashboard:index' %}">
                        <span class="glyphicon glyphicon-briefcase" aria-hidden="true"></span>&nbsp
                        Requests
                    </a>
                </li>
            </ul>


            <form class="navbar-form navbar-left" role="search" method="get" action="#">
                <div class="form-group">
                    <input type="text" class="form-control" name="q" value="">
                </div>
                <button type="submit" class="btn btn-default">Search</button>
            </form>


            <ul class="nav navbar-nav navbar-right">
                <li class="">
                    <a href="{% url 'dashboard:request-add' %}">
                        <span class="glyphicon glyphicon-plus" aria-hidden="true"></span>&nbsp
                        Create Request
                    </a>
                </li>
                <li class="">
                    <a href="#">
                        <span class="glyphicon glyphicon-off" aria-hidden="true"></span>&nbsp
                        Logout
                    </a>
                </li>
            </ul>
        </div>
    </div>
</nav>

{% block body %}
{% endblock %}
</body>
</html>

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/detail.html
{% extends 'dashboard/base.html' %}
{% block title %} Request Details{% endblock %}

{% block body %}

    <h1>{{ request.request_title }}</h1>
    <h3>{{ request.request_description }} </h3>

    {% if error_message %}
        <p><strong>{{ error_message }}</strong></p>
    {% endif %}
{%  endblock %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/form-template.html
{% for field in form %}
    <div class="form-group">
        <label class="control-label col-sm-2">{{ field.label_tag }}</label>
        <div class="col-sm-10">{{ field }}</div>
    </div>
{% endfor %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/index.html
{% extends 'dashboard/base.html' %}
{% block title %} Allocation Manager - Home{% endblock %}
{% block body %}
    {% if all_requests %}
        <h3 style="margin-left: 7%">My Requests</h3>
        <!-- All Requests-->
        <div class="container">
          <table class="table table-hover table-bordered table-striped table-responsive">
            <thead class="thead-inverse">
              <tr style="background-color: #337ab7;color:white">
                <th>Request-ID</th>
                <th>Request Title</th>
                <th>Request Description</th>
                <th>Allocation Requested</th>
                <th>Allocation Status</th>
              </tr>
            </thead>
            <tbody>
                {% for request in all_requests %}
                  <tr>
                    <td>{{ request.id }}</td>
                    <td>{{ request.request_title }}</td>
                    <td>{{ request.request_description }}</td>
                    <td>{{ request.service_units }}</td>
                    <td>{{ request.request_status }}</td>
                  </tr>
                {% endfor %}
            </tbody>
          </table>
        </div>


    {%  else %}
        <h3>You don't have any requests</h3>
    {% endif %}
{%  endblock %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/registration_form.html
{% extends 'dashboard/base.html' %}
{% block title %}Register{% endblock %}
{% block albums_active %}active{% endblock %}

{%  block body %}
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12 col-md-7">
                <div class="panel panel-default">
                    <div class="panel-body">
                        <h3>Create a New Account</h3>
                        <!-- enctype to handle file uploads-->
                        <form class="form-horizontal" action="" method="post" enctype="multipart/form-data">
                            {% csrf_token %}
                            {% include 'dashboard/form-template.html' %}
                            <div class="form-group">
                                <div class="col-sm-offset-2 col-sm-10">
                                    <button type="submit" class="btn btn-success">Submit</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

allocation-manager/django/ResourceAllocationManager/dashboard/templates/dashboard/reviewer.html
{% extends 'dashboard/base.html' %}
{% block title %} Allocation Manager - Reviewer{% endblock %}
{% block body %}
    {% if all_requests %}
        <h3 style="margin-left: 7%">Requests to Review</h3>
        <!-- All Requests-->
        <div class="container">
          <table class="table table-hover table-bordered table-striped table-responsive">
            <thead class="thead-inverse">
              <tr style="background-color: #337ab7;color:white">
                <th>Request-ID</th>
                <th>Request Title</th>
                <th>Request Description</th>
                <th>Allocation Requested</th>
              </tr>
            </thead>
            <tbody>
                {% for request in all_requests %}
                  <tr>
                    <td>{{ request.id }}</td>
                    <td>{{ request.request_title }}</td>
                    <td>{{ request.request_description }}</td>
                    <td>{{ request.service_units}}</td>
                  </tr>
                {% endfor %}
            </tbody>
          </table>
        </div>

    {%  else %}
        <h3>No Requests to Review</h3>
    {% endif %}
{%  endblock %}